﻿using UnityEngine;
using System.Collections;
using System;
using System.Net;
using System.IO;
using UnityEngine.UI;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
public class filereader : MonoBehaviour 
{
    string[] parts = new string[5000];
    public Text text4;
    public Text text3; 

  
    void aaDownloadSpecificFileOnServer(string FILENAME)
    {
        FtpWebRequest request = (FtpWebRequest)WebRequest.Create("ftp://ftp.cluster007.ovh.net/www/data/footballConference/");
        string localPath = Global.LocalFileName1;
        FtpWebRequest requestFileDownload = (FtpWebRequest)WebRequest.Create("ftp://ftp.cluster007.ovh.net/www/data/footballConference/" + FILENAME);
        requestFileDownload.Credentials = new NetworkCredential(Global.Username, Global.Password);
        requestFileDownload.Method = WebRequestMethods.Ftp.DownloadFile;
        FtpWebResponse responseFileDownload = (FtpWebResponse)requestFileDownload.GetResponse();
        Stream responseStream = responseFileDownload.GetResponseStream();
        FileStream writeStream = new FileStream(localPath + "/" + FILENAME, FileMode.Create);
        int Length = 2048;
        Byte[] buffer = new Byte[Length];
        int bytesRead = responseStream.Read(buffer, 0, Length);
        while (bytesRead > 0)
        {
            writeStream.Write(buffer, 0, bytesRead);
            bytesRead = responseStream.Read(buffer, 0, Length);
        }
        responseStream.Close();
        writeStream.Close();
        requestFileDownload = null;
        responseFileDownload = null;

        for (int i = 0; i < Global.timesMax; i++) Global.lineString[i] = "";

        Global.wLineCount = 0;
        using (StreamReader reader = new StreamReader(localPath + "/" + FILENAME))
        {
            string line;
            while ((line = reader.ReadLine()) != null)
            {
                Global.lineString[Global.wLineCount] = line;
                Global.wLineCount++;
            }
        }
    }
    void aaParseFileGPS()
    {
        Global.stackCountGPS = 1;
        for (int i = 0; i < Global.wLineCount; i++)
        {
            int p = 0;
            parts = Global.lineString[i].Split(',');
            Global.sessionCode[Global.stackCountGPS] = parts[p++];
            Global.date[Global.stackCountGPS] = parts[p++];
            Global.week[Global.stackCountGPS] = parts[p++];
            Global.typology[Global.stackCountGPS] = parts[p++];
            Global.sessionName[Global.stackCountGPS] = parts[p++];
            Global.playerName[Global.stackCountGPS] = parts[p++];
            Global.distance[Global.stackCountGPS] = parts[p++];
            Global.speed[Global.stackCountGPS] = parts[p++];
            Global.hsr[Global.stackCountGPS] = parts[p++];
            Global.maxvel[Global.stackCountGPS] = parts[p++];
            Global.rhie[Global.stackCountGPS] = parts[p++];
            Global.greaterthan90[Global.stackCountGPS] = parts[p++];
            Global.maxhr[Global.stackCountGPS] = parts[p++];
            Global.pl[Global.stackCountGPS] = parts[p++];
            Global.plpermin[Global.stackCountGPS] = parts[p++];
            Global.plperslow[Global.stackCountGPS] = parts[p++];
            Global.stackCountGPS++;
        }

        for (int i = 2; i < Global.stackCountGPS; i++)
        {
            if (Global.distance[i] != "#N/A") Global.distance_p1[i] = Convert.ToSingle(Global.distance[i]);
            else Global.distance_p1[i] = 0;
            if (Global.speed[i] != "#N/A") Global.speed_p1[i] = Convert.ToSingle(Global.speed[i]);
            else Global.speed_p1[i] = 0;
            if (Global.hsr[i] != "#N/A") Global.hsr_p1[i] = Convert.ToSingle(Global.hsr[i]);
            else Global.hsr_p1[i] = 0;
            if (Global.maxvel[i] != "") Global.maxvel_p1[i] = Convert.ToSingle(Global.maxvel[i]);
            else Global.maxvel_p1[i] = 0;
            if (Global.rhie[i] != "#N/A") Global.rhie_p1[i] = (float)Convert.ToInt32(Global.rhie[i]);
            else Global.rhie_p1[i] = 0;

            if (Global.maxhr[i] != "#N/A") Global.maxhr_p1[i] = Convert.ToSingle(Global.maxhr[i]);
            else Global.maxhr_p1[i] = 0;
            if (Global.pl[i] != "#N/A") Global.pl_p1[i] = Convert.ToSingle(Global.pl[i]);
            else Global.pl_p1[i] = 0;
            if (Global.plpermin[i] != "#N/A") Global.plpermin_p1[i] = Convert.ToSingle(Global.plpermin[i]);
            else Global.plpermin_p1[i] = 0;
            if (Global.plperslow[i] != "#N/A") Global.plperslow_p1[i] = Convert.ToSingle(Global.plperslow[i]);
            else Global.plperslow_p1[i] = 0;
        }


        for (int i = 2; i < Global.stackCountGPS; i++)
        {
            Global.gpsVar[0, i] = Global.distance_p1[i];
            Global.gpsVar[1, i] = Global.speed_p1[i];
            Global.gpsVar[2, i] = Global.hsr_p1[i];
            Global.gpsVar[3, i] = Global.maxvel_p1[i];
            Global.gpsVar[4, i] = Global.rhie_p1[i];
            Global.gpsVar[5, i] = Global.maxhr_p1[i];
            Global.gpsVar[6, i] = Global.pl_p1[i];
            Global.gpsVar[7, i] = Global.plpermin_p1[i];
            Global.gpsVar[8, i] = Global.plperslow_p1[i];
        }

        Global.gpsName[0] = Global.distance[1];
        Global.gpsName[1] = Global.speed[1];
        Global.gpsName[2] = Global.hsr[1];
        Global.gpsName[3] = Global.maxvel[1];
        Global.gpsName[4] = Global.rhie[1];
        Global.gpsName[5] = Global.maxhr[1];
        Global.gpsName[6] = Global.pl[1];
        Global.gpsName[7] = Global.plpermin[1];
        Global.gpsName[8] = Global.plperslow[1];
    }
    void aaParseFileAnthro()
    {
        Global.stackCountAnthro = 1;
        for (int i = 0; i < Global.wLineCount; i++)
        {
            int p = 0;
            parts = Global.lineString[i].Split(',');
            Global.playerNameAnthro[Global.stackCountAnthro] = parts[p++];
            Global.targetBodyFatAnthro[Global.stackCountAnthro] = parts[p++];
            Global.currentBodyFatAnthro[Global.stackCountAnthro] = parts[p++];
            Global.stackCountAnthro++;
        }

        for (int i = 2; i < Global.stackCountAnthro; i++)
        {
            Global.playerNameAnthro_p1[i]           = Global.playerNameAnthro[i];
            Global.targetBodyFatAnthro_p1[i]        = Convert.ToSingle(Global.targetBodyFatAnthro[i]);
            Global.currentBodyFatAnthro_p1[i]       = Convert.ToSingle(Global.currentBodyFatAnthro[i]);
            Global.currentBodyFatAnthroError_p1[i]  = 100*(Global.currentBodyFatAnthro_p1[i] - Global.targetBodyFatAnthro_p1[i]) / Global.targetBodyFatAnthro_p1[i];
        }
        Global.anthroHeading[0] = Global.playerNameAnthro[1];
        Global.anthroHeading[1] = Global.targetBodyFatAnthro[1];
        Global.anthroHeading[2] = Global.currentBodyFatAnthro[1];
    }
    void aaParseFileMatch()
    {
        DateTime currentDate = DateTime.Now.Date;
        UnityEngine.Debug.Log(currentDate.Date.ToString()); 
        Global.stackCountMatch = 1;
        for (int i = 0; i < Global.wLineCount; i++)
        {
            int p = 0;
            parts = Global.lineString[i].Split(',');
            Global.playerNameMatch[Global.stackCountMatch] = parts[p++];
            Global.dateOfLastGame[Global.stackCountMatch] = parts[p++];
            Global.played[Global.stackCountMatch] = parts[p++];
            Global.willPlay[Global.stackCountMatch] = parts[p++];
            Global.stackCountMatch++;
        }
        for (int i = 2; i < Global.stackCountMatch; i++)
        {
            Global.playerNameMatch_p1[i]    = Global.playerNameMatch[i];
            Global.dateOfLastGame_p1[i]     = Convert.ToDateTime(Global.dateOfLastGame[i]);
            Global.played_p1[i]             = Convert.ToInt32(Global.played[i]);
            Global.willPlay_p1[i]           = Convert.ToInt32(Global.willPlay[i]);
            Global.dateSinceLastGame_p1[i]  = currentDate - Global.dateOfLastGame_p1[i];
        }
        Global.anthroHeading[0]             = Global.playerNameMatch[1];
        Global.anthroHeading[1]             = Global.dateOfLastGame[1];
        Global.anthroHeading[2]             = Global.played[1];
        Global.anthroHeading[3]             = Global.willPlay[1];


    }
    void aaDecideOnScale(int begin, int end)
    {
        for (int i = 0; i < 9; i++)
        {
            Global.gpsMax[i] = 0;
            for (int j = begin; j < end; j++)
            {
                if (Global.gpsVar[i, j] > Global.gpsMax[i]) Global.gpsMax[i] = Global.gpsVar[i, j];
            }
        }

        for (int i = 0; i < 9; i++)
        {
            if (Global.gpsMax[i] > 0)
            {
                for (int j = begin; j < end; j++)
                {
                    Global.gpsNorm[i, j] = Global.gpsVar[i, j] / Global.gpsMax[i];
                }
            }
        }
    }
    void Start()
    {
        aaDownloadSpecificFileOnServer("gpsMaster.csv");
        aaParseFileGPS();
     
        aaDownloadSpecificFileOnServer("anthrometrics.csv");
        aaParseFileAnthro();
  
        aaDownloadSpecificFileOnServer("matchplay.csv");
        aaParseFileMatch();

   
        aaDecideOnScale(2, 650);
        UnityEngine.Debug.Log(Global.dateSinceLastGame_p1[2].TotalDays.ToString());
        
     
        text4.text = Global.dateSinceLastGame_p1[2].ToString();
        text4.text += " " + Global.wLineCount.ToString();
        
        text3.text = Global.distance[1];
        text3.text += "\r\n" + Global.distance[650];
        text3.text += "\r\n" + Global.distance_p1[650];

        for (int i = 2; i<Global.stackCountAnthro; i++ )
        {
            text4.text += "\r\n" + " " + Global.playerNameAnthro_p1[i] + " " + Global.currentBodyFatAnthroError_p1[i].ToString();
        }
        
    }
	
	void Update () 
    {
	
	}
}
